#include <Wire.h>
// NE PAS OUBLIER LES 2 RESISTANCES DE 4,7KOHMS ENTRE SDA ET +5V ET ENTRE SLC ET +5V 

int Windex = 0;
byte I2Cdata[1];
int EventCount=0;
byte val = 0;

void setup() {
  
  // Initialisation de l' I2C
  Wire.begin(121);                
   // rejoindre le bus avec l'adresse #121
  Wire.onReceive(receiveEvent); 
   // enregistrement du handler "receive"
  Wire.onRequest(requestEvent); 
   // enregistrement du handler "request"

}

void loop() {
  
  val++;
  if(val == 64) // if reached 64th position (max)
  {
    val = 0;    // start over from lowest value
  }
  delay(500);
  
}

//------------------------------------------------------
// réception d'un événement I2C
// mode Esclave
// cette fonction "handler" a été enregistrée dans le setup()
//------------------------------------------------------
 
void receiveEvent(int howMany)
{
  byte c;
   
  while(Wire.available()) {
 
  c = Wire.read();          
   // reçoit un octet
  I2Cdata[Windex++] = c;    
   // stockage dans un tampon circulaire
  if (Windex == 64) Windex = 0;
  }
  EventCount++;
}
 
//------------------------------------------------------
// réponse à une requête I2C
// mode Esclave
// cette fonction "handler" a été enregistrée dans le setup()
//------------------------------------------------------
 
void requestEvent()
{
  Wire.write(val); 
   // répond par un message d'un octet
}
